# cgmout.h File Reference

`#include "cgmmach.h"`
`#include "cgmtypes.h"`
`#include "cgmstruc.h"`
`#include "cgmatt.h"`
`#include "cgmerr.h"`

## Defines

#define | REQUAL(x, y) ( FABS((x)-(y)) <= cur.realmin )
#define | VEQUAL(x, y) ( FABS((x)-(y)) <= cur.vdcmin )
#define | PEQUAL(p, q) ( VEQUAL((p)->x, (q)->x) && VEQUAL((p)->y, (q)->y) )
#define | XPROD(a, b, c, d)

## Variables

const struct char_defaults | chardef
char_defaults mfchar curchar | oldchar
const struct text_defaults | textdef
text_defaults mftext | curtext
const struct bin_defaults | bindef
bin_defaults mfbin | curbin
defaults cur | old
attributes curatt | oldatt
flags | att
Enum | cgmdriver
Enum | cgmstate
long * | null
Code | st_start
Code | st_term
Logical | cgmralgks
Logical | cgmverbose
Logical | cgmquiet
Logical | cgmEOF
Logical | cgmfinished
long | cgmnext
long | cgmpresent
long | cgmabort
cgmfont | cgmfonts
cgmcset | cgmcsets

## Define Documentation

#define PEQUAL | ( | p,
|  | q |  | ) | ( VEQUAL((p)->x, (q)->x) && VEQUAL((p)->y, (q)->y) )

#define REQUAL | ( | x,
|  | y |  | ) | ( FABS((x)-(y)) <= cur.realmin )

#define VEQUAL | ( | x,
|  | y |  | ) | ( FABS((x)-(y)) <= cur.vdcmin )

#define XPROD | ( | a,
|  | b,
|  | c,
|  | d |  | ) |

Value:

    ( (b->x - a->x)*(d->y - c->y)\
                           - (d->x - c->x)*(b->y - a->y) )

## Variable Documentation

struct flags att

const struct bin_defaults bindef

long cgmabort

struct cgmcset cgmcsets

Enum cgmdriver

Logical cgmEOF

Logical cgmfinished

struct cgmfont cgmfonts

long cgmnext

long cgmpresent

Logical cgmquiet

Logical cgmralgks

Enum cgmstate

Logical cgmverbose

const struct char_defaults chardef

struct bin_defaults mfbin curbin

struct text_defaults mftext curtext

long* null

struct defaults cur old

struct attributes curatt oldatt

struct char_defaults mfchar curchar oldchar

Code st_start

Code st_term

const struct text_defaults textdef